<?PHP
	include "include/globals.php";
	include "include/mailfunctions.php";

	$mbox = open_mailbox($_SESSION["currentfolder"]);

	if(isset($_POST["movemailb"])) {

		echo("<html><head><script type=\"text/javascript\">\n");

		if(isset($_POST["dragmove"])) {
			echo("		var pg = parent.maillist;\n");
			$_POST["tofolder"] = urldecode(substr($_POST["tofolder"], 23, strrpos($_POST["tofolder"], "'") - 23));
		}
		else {
			echo("		var pg = opener.parent.maillist;\n");
		}

		if (getmailboxname($_SESSION["currentfolder"]) != (getmailboxname($_POST["tofolder"]))) {
			echo("	var index = -1;\n");
			echo("	var nextmessage = '';\n");
			echo("	function DM(mid) {\n");
			echo("		var message = pg.document.getElementById('mess' + mid);\n");
			echo("		if (message.index > index) {\n");
			echo("			index = message.index;\n");
			echo("			if (message != message.parentNode.lastChild) {\n");
			echo("				if (pg.selectedmessages[message.nextSibling.id] != 1) {\n");
			echo("					nextmessage = message.nextSibling;\n");
			echo("				}\n");
			echo("			} else if (message != message.parentNode.firstChild) {\n");
			echo("				if (pg.selectedmessages[message.previousSibling.id] != 1) {\n");
			echo("					nextmessage = message.previousSibling;\n");
			echo("				}\n");
			echo("			}\n");
			echo("		}\n");
			echo("		message.parentNode.removeChild(message);\n");
			echo("		delete(pg.selectedmessages['mess' + mid]);\n");
			echo("	}\n");

			$messagelist = "";
			$messages = array();
			while (list($key, $val) = each($_POST)) {
				if (substr($key, 0, 4) == "mess") {
					$messagelist .= "," . substr($key, 4);
					$messages[count($messages)] = substr($key, 4);
					echo("	DM(" . substr($key, 4) . ");\n");
				}
			}
			$messagelist = substr($messagelist, 1);
			imap_mail_move($mbox, $messagelist, urldecode(str_replace($_SESSION["serverstring"], "", $_POST["tofolder"])), CP_UID);
			imap_setflag_full($mbox, $messagelist, '\\SEEN', ST_UID);
			imap_expunge($mbox);
			echo("	if ((nextmessage != '') && (nextmessage.nodeName != \"#text\")){\n");
			echo("		pg.vm(nextmessage);\n");
			echo("	} else if (nextmessage.nodeName == \"#text\") {\n");
			echo("		pg.location.href = 'maillist.php?newmailbox=" . addslashes($_SESSION["currentfolder"]) . "'\n");
			echo("	}\n");

			// if we are using this in a hidden frame we don't want to close the window, we want to refresh hidden.php
			if(!isset($_POST["reloadhiddenframe"])) {
				echo("	window.close();\n");
			}
			else {
				echo("parent.hiddenframe.location.href='hidden.php';\n");
			}
		}
		echo("</script></head><body></body></html>\n");
		print_r(imap_errors());
		exit;
	}

	function CreateFolderList($folderarr, $mbox) {
		$folders = getfolderlist($mbox);

		echo("	<script type=\"text/javascript\">\n");
		echo("		<!--\n");
		echo("		if (document.getElementById) {\n");
		echo("			var foldertree = new WebFXTree('Inside Systems Mail');\n");
		echo("			foldertree.setBehavior('explorer');\n");
		for($i = 0; $i < count($folders); $i++) {
			echo("			var treenode" . $i . " = new WebFXTreeItem('" . addslashes($folders[$i]["name"]) . "');\n");
			if ($folders[$i]["level"] > 1) {
				for ($j = $i; $j >= 0; $j--) {
					if ($folders[$j]["level"] < $folders[$i]["level"]) {
						echo("			treenode" . $j . ".add(treenode" . $i . ");\n");
						break;
					}
				}
			} else {
				echo("			foldertree.add(treenode" . $i . ");\n");
			}
			if ($folders[$i]["folder"] == $_SESSION["currentfolder"]) {
				echo("			treenode" . $i . ".action = 'javascript:alert(\'" . addslashes(addslashes(gettext("You cannot move mail to the same folder."))) . "\')';\n");
				echo("			var currentfolder = " . $i . ";\n");
			} else if ($folders[$i]["folder"] != "") {
				echo("			treenode" . $i . ".action = 'javascript:MoveToFolder(\'" . urlencode(addslashes($folders[$i]["folder"])) . "\', \'" . addslashes(addslashes($folders[$i]["name"])) . "\')';\n");
			}
		}
		echo("			document.write(foldertree);\n");
		echo("			var obj = document.getElementById('webfx-tree-object-' + (currentfolder + 3) + '-anchor');\n");
		echo("			obj.style.fontStyle = 'italic';\n");
		echo("		}\n");
		echo("		// -->\n");
		echo("	</script>\n");
	}
	
	PageHeader(1);
?>
<head>
	<title><?php echo(gettext("Move Mail to Folder"));?></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/globals.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/xtree.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/folderlists.css";
	</style>
	<script type="text/JavaScript"> <?php include "xtree/xtree.php"; ?></script>
	<script type="text/javascript">
		<!--
		function MoveToFolder(folderval, tofoldername) {
			document.getElementById('headerlabel').firstChild.nodeValue = '<?php echo(addslashes(gettext("Move to")));?> "' + tofoldername + '"';
			document.getElementById('movemailb').value = '<?php echo(addslashes(gettext("Move to")));?> \'' + tofoldername + '\'';
			document.getElementById('tofolder').value = folderval;
		}
		// -->
	</script>
</head>
<body>
<form id="folderform" method="post" action="movemail.php">
	<div id="headercontainer">
		<div id="headerleftcap">
		</div>
		<div id="headerrightcap">
		</div>
		<div id="headerlabel">
			<?php echo(gettext("Move Mail To"));?>:
			<input type="hidden" id="tofolder" name="tofolder" value="none"/>
		</div>
	</div>
	<div id="folders">
		<?php
			$folders = getfolderlist($mbox);
			CreateFolderList($folders, $mbox);
		?>
	</div>
	<div id="submitinput">
		<input id="movemailb" type="submit" value=" <?php echo(gettext("Move Mail"));?> " name="movemailb"/>
	</div>
</form>
<script type="text/javascript">
	<!--
	for (var smess in opener.parent.maillist.selectedmessages) {
		var he = document.createElement('input');
		he.type = 'hidden';
		he.name = smess;
		he.value = '1';
		document.getElementById('folderform').appendChild(he);
	}
	// -->
</script>
</body>
<?php
	// Clear the errors and close the connection
	imap_errors();
	imap_close($mbox);
?>
</html>
